<html>
<head>
<title>OGRE: OgreRadixSort.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreRadixSort.h</h1><a href="OgreRadixSort_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __RadixSort_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __RadixSort_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 
<a name="l00082"></a>00082     <span class="keyword">template</span> &lt;<span class="keyword">class</span> TContainer, <span class="keyword">class</span> TContainerValueType, <span class="keyword">typename</span> TCompValueType&gt;
<a name="l00083"></a><a class="code" href="classOgre_1_1RadixSort.html">00083</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1RadixSort.html" title="Class for performing a radix sort (fast comparison-less sort based on byte value)...">RadixSort</a>
<a name="l00084"></a>00084     {
<a name="l00085"></a>00085     <span class="keyword">public</span>:
<a name="l00086"></a><a class="code" href="classOgre_1_1RadixSort.html#e6832006de9925d59d8795d4f708f08f">00086</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> TContainer::iterator <a class="code" href="classOgre_1_1RadixSort.html#e6832006de9925d59d8795d4f708f08f">ContainerIter</a>;
<a name="l00087"></a>00087     <span class="keyword">protected</span>:
<a name="l00090"></a><a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668">00090</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[4][256];
<a name="l00092"></a><a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64">00092</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[256];
<a name="l00094"></a><a class="code" href="classOgre_1_1RadixSort.html#9c004d058dec49d422482103af7a06dd">00094</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RadixSort.html#9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a>;
<a name="l00096"></a><a class="code" href="classOgre_1_1RadixSort.html#02ac6146623e353cd5c36ffa4eb30373">00096</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RadixSort.html#02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a>;
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html">00098</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>
<a name="l00099"></a>00099         {
<a name="l00100"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#6f46a958afebbd47ff723551f9893d83">00100</a>             TCompValueType <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#6f46a958afebbd47ff723551f9893d83">key</a>;
<a name="l00101"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#e2f0a6d95f201f252c0c555e606268a8">00101</a>             <a class="code" href="classOgre_1_1RadixSort.html#e6832006de9925d59d8795d4f708f08f">ContainerIter</a> <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#e2f0a6d95f201f252c0c555e606268a8">iter</a>;
<a name="l00102"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#2e33f6562eeda7b1d7a6a82492423c03">00102</a>             <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#2e33f6562eeda7b1d7a6a82492423c03">SortEntry</a>() {}
<a name="l00103"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#14793930d53046b5ba9bd53f8cb9084a">00103</a>             <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#2e33f6562eeda7b1d7a6a82492423c03">SortEntry</a>(TCompValueType k, <a class="code" href="classOgre_1_1RadixSort.html#e6832006de9925d59d8795d4f708f08f">ContainerIter</a> it)
<a name="l00104"></a>00104                 : <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#6f46a958afebbd47ff723551f9893d83">key</a>(k), <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#e2f0a6d95f201f252c0c555e606268a8">iter</a>(it) {}
<a name="l00105"></a>00105 
<a name="l00106"></a>00106         };
<a name="l00108"></a><a class="code" href="classOgre_1_1RadixSort.html#2112b0f31c640327366def3806dcab5d">00108</a>         std::vector&lt;SortEntry&gt; <a class="code" href="classOgre_1_1RadixSort.html#2112b0f31c640327366def3806dcab5d" title="Temp sort storage.">mSortArea1</a>;
<a name="l00109"></a><a class="code" href="classOgre_1_1RadixSort.html#d3a26ac464f5b59d75286e9b12cd2994">00109</a>         std::vector&lt;SortEntry&gt; <a class="code" href="classOgre_1_1RadixSort.html#d3a26ac464f5b59d75286e9b12cd2994">mSortArea2</a>;
<a name="l00110"></a><a class="code" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">00110</a>         std::vector&lt;SortEntry&gt;* <a class="code" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a>;
<a name="l00111"></a><a class="code" href="classOgre_1_1RadixSort.html#aeca7c2e0fe32e56d2e373b25d41a329">00111</a>         std::vector&lt;SortEntry&gt;* <a class="code" href="classOgre_1_1RadixSort.html#aeca7c2e0fe32e56d2e373b25d41a329">mDest</a>;
<a name="l00112"></a><a class="code" href="classOgre_1_1RadixSort.html#98e68e712c66b7d02426d76382b4bff4">00112</a>         TContainer <a class="code" href="classOgre_1_1RadixSort.html#98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a>; <span class="comment">// initial copy</span>
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a><a class="code" href="classOgre_1_1RadixSort.html#214c198ead344cf63ea82336b5e63f54">00115</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#214c198ead344cf63ea82336b5e63f54">sortPass</a>(<span class="keywordtype">int</span> byteIndex)
<a name="l00116"></a>00116         {
<a name="l00117"></a>00117             <span class="comment">// Calculate offsets</span>
<a name="l00118"></a>00118             <span class="comment">// Basically this just leaves gaps for duplicate entries to fill</span>
<a name="l00119"></a>00119             <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[0] = 0;
<a name="l00120"></a>00120             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; 256; ++i)
<a name="l00121"></a>00121             {
<a name="l00122"></a>00122                 <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i-1] + <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[byteIndex][i-1];
<a name="l00123"></a>00123             }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125             <span class="comment">// Sort pass</span>
<a name="l00126"></a>00126             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classOgre_1_1RadixSort.html#9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a>; ++i)
<a name="l00127"></a>00127             {
<a name="l00128"></a>00128                 <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byteVal = <a class="code" href="classOgre_1_1RadixSort.html#c54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(byteIndex, (*<a class="code" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a>)[i].key);
<a name="l00129"></a>00129                 (*mDest)[<a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[byteVal]++] = (*mSrc)[i];
<a name="l00130"></a>00130             }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00134"></a><a class="code" href="classOgre_1_1RadixSort.html#024faae2b21a9417983dce5c8167e61f">00134</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#024faae2b21a9417983dce5c8167e61f">finalPass</a>(<span class="keywordtype">int</span> byteIndex, T val)
<a name="l00135"></a>00135         {
<a name="l00136"></a>00136             <span class="comment">// default is to do normal pass</span>
<a name="l00137"></a>00137             <a class="code" href="classOgre_1_1RadixSort.html#214c198ead344cf63ea82336b5e63f54">sortPass</a>(byteIndex);
<a name="l00138"></a>00138         }
<a name="l00139"></a>00139         
<a name="l00140"></a>00140         <span class="comment">// special case signed int</span>
<a name="l00141"></a><a class="code" href="classOgre_1_1RadixSort.html#9d5c1b55a50cded48d3ccbe38182766e">00141</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#024faae2b21a9417983dce5c8167e61f">finalPass</a>(<span class="keywordtype">int</span> byteIndex, <span class="keywordtype">int</span> val)
<a name="l00142"></a>00142         {
<a name="l00143"></a>00143             <span class="keywordtype">int</span> numNeg = 0;
<a name="l00144"></a>00144             <span class="comment">// all negative values are in entries 128+ in most significant byte</span>
<a name="l00145"></a>00145             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 128; i &lt; 256; ++i)
<a name="l00146"></a>00146             {
<a name="l00147"></a>00147                 numNeg += <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[byteIndex][i];
<a name="l00148"></a>00148             }
<a name="l00149"></a>00149             <span class="comment">// Calculate offsets - positive ones start at the number of negatives</span>
<a name="l00150"></a>00150             <span class="comment">// do positive numbers</span>
<a name="l00151"></a>00151             <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[0] = numNeg;
<a name="l00152"></a>00152             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; 128; ++i)
<a name="l00153"></a>00153             {
<a name="l00154"></a>00154                 <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i-1] + <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[byteIndex][i-1];
<a name="l00155"></a>00155             }
<a name="l00156"></a>00156             <span class="comment">// Do negative numbers (must start at zero)</span>
<a name="l00157"></a>00157             <span class="comment">// No need to invert ordering, already correct (-1 is highest number)</span>
<a name="l00158"></a>00158             <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[128] = 0;
<a name="l00159"></a>00159             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 129; i &lt; 256; ++i)
<a name="l00160"></a>00160             {
<a name="l00161"></a>00161                 <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i-1] + <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[byteIndex][i-1];
<a name="l00162"></a>00162             }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164             <span class="comment">// Sort pass</span>
<a name="l00165"></a>00165             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classOgre_1_1RadixSort.html#9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a>; ++i)
<a name="l00166"></a>00166             {
<a name="l00167"></a>00167                 <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byteVal = <a class="code" href="classOgre_1_1RadixSort.html#c54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(byteIndex, (*<a class="code" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a>)[i].key);
<a name="l00168"></a>00168                 (*mDest)[<a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[byteVal]++] = (*mSrc)[i];
<a name="l00169"></a>00169             }
<a name="l00170"></a>00170         }
<a name="l00171"></a>00171         
<a name="l00172"></a>00172 
<a name="l00173"></a>00173         <span class="comment">// special case float</span>
<a name="l00174"></a><a class="code" href="classOgre_1_1RadixSort.html#985875ef2e1f317eea143cac7b7dc529">00174</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#024faae2b21a9417983dce5c8167e61f">finalPass</a>(<span class="keywordtype">int</span> byteIndex, <span class="keywordtype">float</span> val)
<a name="l00175"></a>00175         {
<a name="l00176"></a>00176             <span class="comment">// floats need to be special cased since negative numbers will come</span>
<a name="l00177"></a>00177             <span class="comment">// after positives (high bit = sign) and will be in reverse order</span>
<a name="l00178"></a>00178             <span class="comment">// (no ones-complement of the +ve value)</span>
<a name="l00179"></a>00179             <span class="keywordtype">int</span> numNeg = 0;
<a name="l00180"></a>00180             <span class="comment">// all negative values are in entries 128+ in most significant byte</span>
<a name="l00181"></a>00181             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 128; i &lt; 256; ++i)
<a name="l00182"></a>00182             {
<a name="l00183"></a>00183                 numNeg += <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[byteIndex][i];
<a name="l00184"></a>00184             }
<a name="l00185"></a>00185             <span class="comment">// Calculate offsets - positive ones start at the number of negatives</span>
<a name="l00186"></a>00186             <span class="comment">// do positive numbers normally</span>
<a name="l00187"></a>00187             <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[0] = numNeg;
<a name="l00188"></a>00188             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; 128; ++i)
<a name="l00189"></a>00189             {
<a name="l00190"></a>00190                 <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i-1] + <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[byteIndex][i-1];
<a name="l00191"></a>00191             }
<a name="l00192"></a>00192             <span class="comment">// Do negative numbers (must start at zero)</span>
<a name="l00193"></a>00193             <span class="comment">// Also need to invert ordering</span>
<a name="l00194"></a>00194             <span class="comment">// In order to preserve the stability of the sort (essential since</span>
<a name="l00195"></a>00195             <span class="comment">// we rely on previous bytes already being sorted) we have to count</span>
<a name="l00196"></a>00196             <span class="comment">// backwards in our offsets from </span>
<a name="l00197"></a>00197             <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[255] = <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[byteIndex][255];
<a name="l00198"></a>00198             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 254; i &gt; 127; --i)
<a name="l00199"></a>00199             {
<a name="l00200"></a>00200                 <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i+1] + <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[byteIndex][i];
<a name="l00201"></a>00201             }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203             <span class="comment">// Sort pass</span>
<a name="l00204"></a>00204             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classOgre_1_1RadixSort.html#9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a>; ++i)
<a name="l00205"></a>00205             {
<a name="l00206"></a>00206                 <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byteVal = <a class="code" href="classOgre_1_1RadixSort.html#c54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(byteIndex, (*<a class="code" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a>)[i].key);
<a name="l00207"></a>00207                 <span class="keywordflow">if</span> (byteVal &gt; 127)
<a name="l00208"></a>00208                 {
<a name="l00209"></a>00209                     <span class="comment">// -ve; pre-decrement since offsets set to count</span>
<a name="l00210"></a>00210                     (*mDest)[--<a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[byteVal]] = (*mSrc)[i];
<a name="l00211"></a>00211                 }
<a name="l00212"></a>00212                 <span class="keywordflow">else</span>
<a name="l00213"></a>00213                 {
<a name="l00214"></a>00214                     <span class="comment">// +ve</span>
<a name="l00215"></a>00215                     (*mDest)[<a class="code" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[byteVal]++] = (*mSrc)[i];
<a name="l00216"></a>00216                 }
<a name="l00217"></a>00217             }
<a name="l00218"></a>00218         }
<a name="l00219"></a>00219 
<a name="l00220"></a><a class="code" href="classOgre_1_1RadixSort.html#c54a7d0ddf8b1f42f4d33dc0b9aec0cd">00220</a>         <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classOgre_1_1RadixSort.html#c54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(<span class="keywordtype">int</span> byteIndex, TCompValueType val)
<a name="l00221"></a>00221         {
<a name="l00222"></a>00222 <span class="preprocessor">#if OGRE_ENDIAN == OGRE_ENDIAN_LITTLE</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span>            <span class="keywordflow">return</span> ((<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*)(&amp;val))[byteIndex];
<a name="l00224"></a>00224 <span class="preprocessor">#else</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>            <span class="keywordflow">return</span> ((<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*)(&amp;val))[<a class="code" href="classOgre_1_1RadixSort.html#02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a> - byteIndex - 1];
<a name="l00226"></a>00226 <span class="preprocessor">#endif</span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>        }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229     <span class="keyword">public</span>:
<a name="l00230"></a>00230 
<a name="l00231"></a><a class="code" href="classOgre_1_1RadixSort.html#2c982200600a22b21906e3f43a0a962d">00231</a>         <a class="code" href="classOgre_1_1RadixSort.html#2c982200600a22b21906e3f43a0a962d">RadixSort</a>() {}
<a name="l00232"></a><a class="code" href="classOgre_1_1RadixSort.html#8f49cae4360e7c83b6ca7cf5714db761">00232</a>         <a class="code" href="classOgre_1_1RadixSort.html#8f49cae4360e7c83b6ca7cf5714db761">~RadixSort</a>() {}
<a name="l00233"></a>00233 
<a name="l00239"></a>00239         <span class="keyword">template</span> &lt;<span class="keyword">class</span> TFunction&gt;
<a name="l00240"></a><a class="code" href="classOgre_1_1RadixSort.html#b3a589546b32250272870bd0cd471116">00240</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#b3a589546b32250272870bd0cd471116" title="Main sort function.">sort</a>(TContainer&amp; container, TFunction func)
<a name="l00241"></a>00241         {
<a name="l00242"></a>00242             <span class="keywordflow">if</span> (container.empty())
<a name="l00243"></a>00243                 <span class="keywordflow">return</span>;
<a name="l00244"></a>00244 
<a name="l00245"></a>00245             <span class="comment">// Set up the sort areas</span>
<a name="l00246"></a>00246             <a class="code" href="classOgre_1_1RadixSort.html#9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(container.size());
<a name="l00247"></a>00247             <a class="code" href="classOgre_1_1RadixSort.html#2112b0f31c640327366def3806dcab5d" title="Temp sort storage.">mSortArea1</a>.resize(container.size());
<a name="l00248"></a>00248             <a class="code" href="classOgre_1_1RadixSort.html#d3a26ac464f5b59d75286e9b12cd2994">mSortArea2</a>.resize(container.size());
<a name="l00249"></a>00249 
<a name="l00250"></a>00250             <span class="comment">// Copy data now (we need constant iterators for sorting)</span>
<a name="l00251"></a>00251             <a class="code" href="classOgre_1_1RadixSort.html#98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a> = container;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253             <a class="code" href="classOgre_1_1RadixSort.html#02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a> = <span class="keyword">sizeof</span>(TCompValueType);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255             <span class="comment">// Counter pass</span>
<a name="l00256"></a>00256             <span class="comment">// Initialise the counts</span>
<a name="l00257"></a>00257             <span class="keywordtype">int</span> p;
<a name="l00258"></a>00258             <span class="keywordflow">for</span> (p = 0; p &lt; <a class="code" href="classOgre_1_1RadixSort.html#02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a>; ++p)
<a name="l00259"></a>00259                 memset(<a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[p], 0, <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>) * 256);
<a name="l00260"></a>00260 
<a name="l00261"></a>00261             <span class="comment">// Perform alpha pass to count</span>
<a name="l00262"></a>00262             <a class="code" href="classOgre_1_1RadixSort.html#e6832006de9925d59d8795d4f708f08f">ContainerIter</a> i = <a class="code" href="classOgre_1_1RadixSort.html#98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a>.begin();
<a name="l00263"></a>00263             TCompValueType prevValue = func.operator()(*i); 
<a name="l00264"></a>00264             <span class="keywordtype">bool</span> needsSorting = <span class="keyword">false</span>;
<a name="l00265"></a>00265             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> u = 0; i != <a class="code" href="classOgre_1_1RadixSort.html#98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a>.end(); ++i, ++u)
<a name="l00266"></a>00266             {
<a name="l00267"></a>00267                 <span class="comment">// get sort value</span>
<a name="l00268"></a>00268                 TCompValueType val = func.operator()(*i);
<a name="l00269"></a>00269                 <span class="comment">// cheap check to see if needs sorting (temporal coherence)</span>
<a name="l00270"></a>00270                 <span class="keywordflow">if</span> (!needsSorting &amp;&amp; val &lt; prevValue)
<a name="l00271"></a>00271                     needsSorting = <span class="keyword">true</span>;
<a name="l00272"></a>00272 
<a name="l00273"></a>00273                 <span class="comment">// Create a sort entry</span>
<a name="l00274"></a>00274                 <a class="code" href="classOgre_1_1RadixSort.html#2112b0f31c640327366def3806dcab5d" title="Temp sort storage.">mSortArea1</a>[u].key = val;
<a name="l00275"></a>00275                 <a class="code" href="classOgre_1_1RadixSort.html#2112b0f31c640327366def3806dcab5d" title="Temp sort storage.">mSortArea1</a>[u].iter = i;
<a name="l00276"></a>00276 
<a name="l00277"></a>00277                 <span class="comment">// increase counters</span>
<a name="l00278"></a>00278                 <span class="keywordflow">for</span> (p = 0; p &lt; mNumPasses; ++p)
<a name="l00279"></a>00279                 {
<a name="l00280"></a>00280                     <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byteVal = <a class="code" href="classOgre_1_1RadixSort.html#c54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(p, val);
<a name="l00281"></a>00281                     <a class="code" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum...">mCounters</a>[p][byteVal]++;
<a name="l00282"></a>00282                 }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284                 prevValue = val;
<a name="l00285"></a>00285 
<a name="l00286"></a>00286             }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288             <span class="comment">// early exit if already sorted</span>
<a name="l00289"></a>00289             <span class="keywordflow">if</span> (!needsSorting)
<a name="l00290"></a>00290                 <span class="keywordflow">return</span>;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293             <span class="comment">// Sort passes</span>
<a name="l00294"></a>00294             <a class="code" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a> = &amp;<a class="code" href="classOgre_1_1RadixSort.html#2112b0f31c640327366def3806dcab5d" title="Temp sort storage.">mSortArea1</a>;
<a name="l00295"></a>00295             <a class="code" href="classOgre_1_1RadixSort.html#aeca7c2e0fe32e56d2e373b25d41a329">mDest</a> = &amp;<a class="code" href="classOgre_1_1RadixSort.html#d3a26ac464f5b59d75286e9b12cd2994">mSortArea2</a>;
<a name="l00296"></a>00296 
<a name="l00297"></a>00297             <span class="keywordflow">for</span> (p = 0; p &lt; mNumPasses - 1; ++p)
<a name="l00298"></a>00298             {
<a name="l00299"></a>00299                 <a class="code" href="classOgre_1_1RadixSort.html#214c198ead344cf63ea82336b5e63f54">sortPass</a>(p);
<a name="l00300"></a>00300                 <span class="comment">// flip src/dst</span>
<a name="l00301"></a>00301                 std::vector&lt;SortEntry&gt;* tmp = <a class="code" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a>;
<a name="l00302"></a>00302                 <a class="code" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a> = <a class="code" href="classOgre_1_1RadixSort.html#aeca7c2e0fe32e56d2e373b25d41a329">mDest</a>;
<a name="l00303"></a>00303                 <a class="code" href="classOgre_1_1RadixSort.html#aeca7c2e0fe32e56d2e373b25d41a329">mDest</a> = tmp;
<a name="l00304"></a>00304             }
<a name="l00305"></a>00305             <span class="comment">// Final pass may differ, make polymorphic</span>
<a name="l00306"></a>00306             <a class="code" href="classOgre_1_1RadixSort.html#024faae2b21a9417983dce5c8167e61f">finalPass</a>(p, prevValue);
<a name="l00307"></a>00307 
<a name="l00308"></a>00308             <span class="comment">// Copy everything back</span>
<a name="l00309"></a>00309             <span class="keywordtype">int</span> c = 0;
<a name="l00310"></a>00310             <span class="keywordflow">for</span> (i = container.begin(); 
<a name="l00311"></a>00311                 i != container.end(); ++i, ++c)
<a name="l00312"></a>00312             {
<a name="l00313"></a>00313                 *i = *((*mDest)[c].iter);
<a name="l00314"></a>00314             }
<a name="l00315"></a>00315         }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317     };
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 <span class="preprocessor">#endif</span>
<a name="l00322"></a>00322 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
